%define name            saxon
%define version         6.5.2
%define funky_version   6_5_2
%define release         5jpp
%define javadir         %{_datadir}/java
%define javadocdir      %{_datadir}/javadoc
%define section         free

Name:	        %{name}
Version:        %{version}
Release:        %{release}
Summary:        Java XSLT processor
License:        MPL
Group:	        Text Processing/Markup/XML
Vendor:	        JPackage Project
Distribution:   JPackage
URL:            http://saxon.sourceforge.net/
Source0:        http://download.sf.net/%{name}/%{name}%{funky_version}.zip
Source1:        %{name}.saxon.script
Source2:        %{name}.build.script
Provides:       jaxp_transform_impl
Requires:       /usr/sbin/update-alternatives
Requires:       jaxp_parser_impl
BuildRequires:  xml-commons-apis
BuildRequires:  jdom >= 1.0-0.b7
BuildRequires:  fop >= 0.20.1
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The SAXON package is a collection of tools for processing XML documents.
The main components are:
- An XSLT processor, which implements the Version 1.0 XSLT and XPath
  Recommendations from the World Wide Web Consortium, found at
  http://www.w3.org/TR/1999/REC-xslt-19991116 and
  http://www.w3.org/TR/1999/REC-xpath-19991116 with a number of powerful
  extensions. This version of Saxon also includes many of the new features
  defined in the XSLT 1.1 working draft, but for conformance and portability
  reasons these are not available if the stylesheet header specifies
  version="1.0".
- A Java library, which supports a similar processing model to XSL, but allows
  full programming capability, which you need if you want to perform complex
  processing of the data or to access external services such as a relational
  database.
So you can use SAXON with any SAX-compliant XML parser by writing XSLT
stylesheets, by writing Java applications, or by any combination of the two.

%package aelfred
Summary:        Java XML parser
Group:          Text Processing/Markup/XML
#Provides:       jaxp_parser_impl
#Requires:       /usr/sbin/update-alternatives
Requires:       xml-commons-apis

%description aelfred
A slightly improved version of the AElfred Java XML parser from Microstar.

%package manual
Summary:        Manual for %{name}
Group:          Text Processing/Markup/XML

%description manual
Manual for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%package demo
Summary:        Demos for %{name}
Group:          Text Processing/Markup/XML
Requires:       %{name} = %{version}-%{release}

%description demo
Demonstrations and samples for %{name}.

%package fop
Summary:        FOP support for %{name}
Group:          Text Processing/Markup/XML
Requires:       %{name} = %{version}-%{release}
Requires:       fop >= 0.20.1

%description fop
FOP support for %{name}.

%package jdom
Summary:        JDOM support for %{name}
Group:          Text Processing/Markup/XML
Requires:       %{name} = %{version}-%{release}
Requires:       jdom >= 1.0-0.b7

%description jdom
JDOM support for %{name}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -c
# cleanup unnecessary stuff we'll build ourselves
rm -rf *.jar docs/api
unzip -q source.zip
cp %{SOURCE2} ./build.xml

%build
export CLASSPATH=\
%{javadir}/xml-commons-apis.jar:\
%{javadir}/fop.jar:\
%{javadir}/jdom.jar
# For some reason, -fop won't compile with jikes.
ant -Dbuild.compiler=modern

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{javadir}
install -m 644 build/lib/%{name}.jar $RPM_BUILD_ROOT%{javadir}/%{name}-%{version}.jar
install -m 644 build/lib/%{name}-aelfred.jar $RPM_BUILD_ROOT%{javadir}/%{name}-aelfred-%{version}.jar
install -m 644 build/lib/%{name}-fop.jar $RPM_BUILD_ROOT%{javadir}/%{name}-fop-%{version}.jar
install -m 644 build/lib/%{name}-jdom.jar $RPM_BUILD_ROOT%{javadir}/%{name}-jdom-%{version}.jar
(cd $RPM_BUILD_ROOT%{javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}
cp -pr build/api/* $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}/
# demo
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -pr samples/* $RPM_BUILD_ROOT%{_datadir}/%{name}/
# scripts
install -D -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives --install %{javadir}/jaxp_transform_impl.jar jaxp_transform_impl %{javadir}/%{name}-%{version}.jar 25

#%post aelfred
#update-alternatives --install %{javadir}/jaxp_parser_impl.jar jaxp_parser_impl %{javadir}/%{name}-aelfred-%{version}.jar 5

%postun
update-alternatives --remove jaxp_transform_impl %{javadir}/%{name}-%{version}.jar

#%postun aelfred
#update-alternatives --remove jaxp_parser_impl %{javadir}/%{name}-aelfred-%{version}.jar

%files
%defattr(-,root,root,-)
%{_bindir}/*
%{javadir}/%{name}.jar
%{javadir}/%{name}-%{version}.jar

%files aelfred
%defattr(-,root,root,-)
%{javadir}/%{name}-aelfred*

%files fop
%defattr(-,root,root,-)
%{javadir}/%{name}-fop*

%files jdom
%defattr(-,root,root,-)
%{javadir}/%{name}-jdom*

%files manual
%defattr(-,root,root,-)
%doc doc/*.html

%files javadoc
%defattr(-,root,root,-)
%{javadocdir}/%{name}-%{version}

%files demo
%defattr(-,root,root,-)
%{_datadir}/%{name}

%changelog
* Thu Jul 25 2002 Ville Skytt <ville.skytta at iki.fi> 6.5.2-5jpp
- Fix shell script (again).
- Rebuild with -Dbuild.compiler=modern (saxon-fop won't build with jikes).

* Fri Jul 19 2002 Ville Skytt <ville.skytta at iki.fi> 6.5.2-4jpp
- First public JPackage release.
- Compile with build.xml by yours truly.
- AElfred no more provides jaxp_parser_impl; it's SAX only, no DOM.
- Fix shell script.

* Mon Jul  1 2002 Ville Skytt <ville.skytta at iki.fi> 6.5.2-3jpp
- Provides jaxp_parser_impl.
- Requires xml-commons-apis.

* Sun Jun 30 2002 Ville Skytt <ville.skytta at iki.fi> 6.5.2-2jpp
- Use sed instead of bash 2 extension when symlinking jars.
- Provides jaxp_transform_impl.

* Sat May 11 2002 Ville Skytt <ville.skytta at iki.fi> 6.5.2-1jpp
- First JPackage release.
- Provides jaxp_parser2 though there's no DOM implementation in this AElfred.
